// Copyright (C) 2021-2024 Bundesministerium des Innern und für Heimat, Referat DG II 6, Maßnahmen Enterprise Resource Management und Elektronische Verwaltungsarbeit
//
// SPDX-License-Identifier: MPL-2.0

// tslint:disable
/**
 * eGesetzgebung Platform
 * This is the rest interface offered by the eGesetzgebung Platform backend.  Please provide __JW Access Token__ using button \'Authorize\' to access protected endpoints. Use the following instructions to get token:  1. on CMD/Bash/Terminal: ```curl -d \"client_id=user-management\" -d \"client_secret=INSERT_IAM_SECRET\" -d \"grant_type=password&username=INSERT_USER_EMAIL&password=INSERT_USER_PASSWORD\" \"INSERT_IAM_URL/realms/bund/protocol/openid-connect/token\"``` 2. copy access_token (without quotes, you can use jq or other tools to extract this value automatically) 3. insert value into \'JWToken\' field under \'Authorize\' and press \'Authorize\' 4. now you should have access to user protected endpoint  __FYI:__ token expires after 60 seconds. On non-production systems only a warning is displayed so you can work smoothly, but on production systems you have to frequently provide a new token.
 *
 * The version of the OpenAPI document: 9.0.3
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import type { Observable } from 'rxjs';
import type { AjaxResponse } from 'rxjs/ajax';
import { BaseAPI, throwIfNullOrUndefined, encodeURI } from '../runtime';
import type { OperationOpts, HttpHeaders, HttpQuery } from '../runtime';
import type {
    BoxString,
    FarbeType,
    FreigegebenType,
    PageRegelungsvorhabenEntityResponseShortDTO,
    PaginierungDTO,
    PkpGesendetStatusType,
    RegelungsvorhabenBestandsrechtCreateDTO,
    RegelungsvorhabenBestandsrechtTableDTO,
    RegelungsvorhabenBundesratTableDTOs,
    RegelungsvorhabenBundesregierungTableDTOs,
    RegelungsvorhabenBundestagTableDTOs,
    RegelungsvorhabenEntityDTO,
    RegelungsvorhabenEntityFullResponseDTO,
    RegelungsvorhabenEntityListResponseShortDTO,
    RegelungsvorhabenEntityResponseDTO,
    RegelungsvorhabenFachadminTableDTO,
    RegelungsvorhabenPpkTableDTO,
    RegelungsvorhabenZuleitungCreateDTO,
    RegelungsvorhabenZuleitungTableDTO,
    RueckmeldungType,
    RvFileEntityResponseDTO,
    RvProzesshilfeOverviewDTO,
    TagesordnungsrelevanzDTO,
    VorhabenStatusType,
} from '../models';

export interface ArchiveRegelungsvorhabenRequest {
    id: string;
}

export interface CreateRegelungsvorhabenRequest {
    regelungsvorhabenEntityDTO: RegelungsvorhabenEntityDTO;
    pkpRvId?: string;
}

export interface CreateRegelungsvorhabenBestandsrechtRequest {
    id: string;
    regelungsvorhabenBestandsrechtCreateDTO: Array<RegelungsvorhabenBestandsrechtCreateDTO>;
}

export interface CreateRegelungsvorhabenZuleitungRequest {
    id: string;
    regelungsvorhabenZuleitungCreateDTO: RegelungsvorhabenZuleitungCreateDTO;
}

export interface DeleteRegelungsvorhabenRequest {
    id: string;
}

export interface GetArchivRequest {
    paginierungDTO: PaginierungDTO;
}

export interface GetArchivBundesratRequest {
    paginierungDTO: PaginierungDTO;
}

export interface GetArchivBundestagRequest {
    paginierungDTO: PaginierungDTO;
}

export interface GetBrDrucksachennummerRequest {
    id: string;
}

export interface GetEntwuerfeRequest {
    paginierungDTO: PaginierungDTO;
}

export interface GetEntwuerfeBundestagRequest {
    paginierungDTO: PaginierungDTO;
}

export interface GetMeineRegelungsvorhabenRequest {
    paginierungDTO: PaginierungDTO;
}

export interface GetMeineRegelungsvorhabenBundesratGETRequest {
    eRSTELLER?: string;
    iNITIANTUSER?: string;
    iNITIANTINSTITUTION?: string;
    vORHABENART?: string;
    page?: number;
    size?: number;
    sort?: Array<string>;
    permissibleStatuses?: Array<VorhabenStatusType>;
    permissibleZuleitungFreigegebenFuer?: Array<FreigegebenType>;
}

export interface GetMeineRegelungsvorhabenBundestagRequest {
    paginierungDTO: PaginierungDTO;
}

export interface GetProzesshilfeUebersichtRequest {
    id: string;
}

export interface GetProzesshilfeUebersichtNoAuthRequest {
    id: string;
}

export interface GetRegelungsvorhabenRequest {
    id: string;
}

export interface GetRegelungsvorhabenBestandsrechtTableRequest {
    id: string;
}

export interface GetRegelungsvorhabenFachadministratorRequest {
    paginierungDTO: PaginierungDTO;
}

export interface GetRegelungsvorhabenFullRequest {
    id: string;
}

export interface GetRegelungsvorhabenShortRequest {
    permissibleStatuses?: Array<VorhabenStatusType>;
    permissibleZuleitungFreigegebenFuer?: Array<FreigegebenType>;
    permissibleZuleitungRueckmeldung?: Array<RueckmeldungType>;
    requireUmlaufNull?: boolean;
    requireGrunddrucksacheExists?: boolean;
    page?: number;
    size?: number;
    sort?: Array<string>;
}

export interface GetRegelungsvorhabenShortListWithoutUmlaufRequest {
    permissibleStatuses?: Array<VorhabenStatusType>;
    permissibleZuleitungFreigegebenFuer?: Array<FreigegebenType>;
    permissibleZuleitungRueckmeldung?: Array<RueckmeldungType>;
    requireUmlaufNull?: boolean;
    requireGrunddrucksacheExists?: boolean;
    page?: number;
    size?: number;
    sort?: Array<string>;
}

export interface GetRegelungsvorhabenZuleitungTableRequest {
    id: string;
}

export interface GetRegelungsvorhabenZuleitungTableBundestagRequest {
    id: string;
}

export interface GetRvFilesRequest {
    id: string;
}

export interface GetTagesordnungsrelevanzRequest {
    id: string;
}

export interface ModifyRegelungsvorhabenRequest {
    id: string;
    regelungsvorhabenEntityDTO: RegelungsvorhabenEntityDTO;
}

export interface ModifyRvFarbeRequest {
    id: string;
    farbeType: FarbeType;
}

export interface ModifyTagesordnungsrelevanzRequest {
    id: string;
    tagesordnungsrelevanzDTO: TagesordnungsrelevanzDTO;
}

export interface SendRvToPkpRequest {
    id: string;
}

/**
 * no description
 */
export class RegelungsvorhabenControllerApi extends BaseAPI {

    /**
     * Archiviert ein Regelungsvorhaben
     * Archiviert ein Regelungsvorhaben
     */
    archiveRegelungsvorhaben({ id }: ArchiveRegelungsvorhabenRequest): Observable<void>
    archiveRegelungsvorhaben({ id }: ArchiveRegelungsvorhabenRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    archiveRegelungsvorhaben({ id }: ArchiveRegelungsvorhabenRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(id, 'id', 'archiveRegelungsvorhaben');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/regelungsvorhaben/{id}/archivieren'.replace('{id}', encodeURI(id)),
            method: 'PUT',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Legt ein neues Regelungsvorhaben an. Wenn der Parameter pkpRvId gesetzt ist, wird das RV mit PKP verknüpft
     * Erstellt ein Regelungsvorhaben
     */
    createRegelungsvorhaben({ regelungsvorhabenEntityDTO, pkpRvId }: CreateRegelungsvorhabenRequest): Observable<RegelungsvorhabenEntityResponseDTO>
    createRegelungsvorhaben({ regelungsvorhabenEntityDTO, pkpRvId }: CreateRegelungsvorhabenRequest, opts?: OperationOpts): Observable<AjaxResponse<RegelungsvorhabenEntityResponseDTO>>
    createRegelungsvorhaben({ regelungsvorhabenEntityDTO, pkpRvId }: CreateRegelungsvorhabenRequest, opts?: OperationOpts): Observable<RegelungsvorhabenEntityResponseDTO | AjaxResponse<RegelungsvorhabenEntityResponseDTO>> {
        throwIfNullOrUndefined(regelungsvorhabenEntityDTO, 'regelungsvorhabenEntityDTO', 'createRegelungsvorhaben');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        const query: HttpQuery = {};

        if (pkpRvId != null) { query['pkpRvId'] = pkpRvId; }

        return this.request<RegelungsvorhabenEntityResponseDTO>({
            url: '/regelungsvorhaben',
            method: 'POST',
            headers,
            query,
            body: regelungsvorhabenEntityDTO,
        }, opts?.responseOpts);
    };

    /**
     * Legt ein neues Bestandsrecht im Regelungsvorhaben an
     * Erstellt ein Bestandsrecht
     */
    createRegelungsvorhabenBestandsrecht({ id, regelungsvorhabenBestandsrechtCreateDTO }: CreateRegelungsvorhabenBestandsrechtRequest): Observable<void>
    createRegelungsvorhabenBestandsrecht({ id, regelungsvorhabenBestandsrechtCreateDTO }: CreateRegelungsvorhabenBestandsrechtRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    createRegelungsvorhabenBestandsrecht({ id, regelungsvorhabenBestandsrechtCreateDTO }: CreateRegelungsvorhabenBestandsrechtRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(id, 'id', 'createRegelungsvorhabenBestandsrecht');
        throwIfNullOrUndefined(regelungsvorhabenBestandsrechtCreateDTO, 'regelungsvorhabenBestandsrechtCreateDTO', 'createRegelungsvorhabenBestandsrecht');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/regelungsvorhaben/{id}/bestandsrecht'.replace('{id}', encodeURI(id)),
            method: 'POST',
            headers,
            body: regelungsvorhabenBestandsrechtCreateDTO,
        }, opts?.responseOpts);
    };

    /**
     * Legt eine neue Zuleitung im Regelungsvorhaben an
     * Erstellt eine Zuleitung
     */
    createRegelungsvorhabenZuleitung({ id, regelungsvorhabenZuleitungCreateDTO }: CreateRegelungsvorhabenZuleitungRequest): Observable<void>
    createRegelungsvorhabenZuleitung({ id, regelungsvorhabenZuleitungCreateDTO }: CreateRegelungsvorhabenZuleitungRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    createRegelungsvorhabenZuleitung({ id, regelungsvorhabenZuleitungCreateDTO }: CreateRegelungsvorhabenZuleitungRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(id, 'id', 'createRegelungsvorhabenZuleitung');
        throwIfNullOrUndefined(regelungsvorhabenZuleitungCreateDTO, 'regelungsvorhabenZuleitungCreateDTO', 'createRegelungsvorhabenZuleitung');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/regelungsvorhaben/{id}/zuleitung'.replace('{id}', encodeURI(id)),
            method: 'POST',
            headers,
            body: regelungsvorhabenZuleitungCreateDTO,
        }, opts?.responseOpts);
    };

    /**
     * Löscht einen Regelungsvorhaben-Entwurf
     * Löscht ein Regelungsvorhaben
     */
    deleteRegelungsvorhaben({ id }: DeleteRegelungsvorhabenRequest): Observable<void>
    deleteRegelungsvorhaben({ id }: DeleteRegelungsvorhabenRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    deleteRegelungsvorhaben({ id }: DeleteRegelungsvorhabenRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(id, 'id', 'deleteRegelungsvorhaben');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/regelungsvorhaben/{id}'.replace('{id}', encodeURI(id)),
            method: 'DELETE',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Ruft die Liste der archivierten Regelungsvorhaben ab (»Archiv«)
     * Lädt die Tabelle der Regelungsvorhaben für den Tab »Archiv«
     */
    getArchiv({ paginierungDTO }: GetArchivRequest): Observable<RegelungsvorhabenBundesregierungTableDTOs>
    getArchiv({ paginierungDTO }: GetArchivRequest, opts?: OperationOpts): Observable<AjaxResponse<RegelungsvorhabenBundesregierungTableDTOs>>
    getArchiv({ paginierungDTO }: GetArchivRequest, opts?: OperationOpts): Observable<RegelungsvorhabenBundesregierungTableDTOs | AjaxResponse<RegelungsvorhabenBundesregierungTableDTOs>> {
        throwIfNullOrUndefined(paginierungDTO, 'paginierungDTO', 'getArchiv');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<RegelungsvorhabenBundesregierungTableDTOs>({
            url: '/regelungsvorhaben/archiv',
            method: 'POST',
            headers,
            body: paginierungDTO,
        }, opts?.responseOpts);
    };

    /**
     * Ruft die Liste der archivierten Regelungsvorhaben ab (»Archiv«).
     * Lädt die Tabelle der Regelungsvorhaben für Bundesrats-Tab »Archiv«
     */
    getArchivBundesrat({ paginierungDTO }: GetArchivBundesratRequest): Observable<RegelungsvorhabenBundesratTableDTOs>
    getArchivBundesrat({ paginierungDTO }: GetArchivBundesratRequest, opts?: OperationOpts): Observable<AjaxResponse<RegelungsvorhabenBundesratTableDTOs>>
    getArchivBundesrat({ paginierungDTO }: GetArchivBundesratRequest, opts?: OperationOpts): Observable<RegelungsvorhabenBundesratTableDTOs | AjaxResponse<RegelungsvorhabenBundesratTableDTOs>> {
        throwIfNullOrUndefined(paginierungDTO, 'paginierungDTO', 'getArchivBundesrat');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<RegelungsvorhabenBundesratTableDTOs>({
            url: '/regelungsvorhaben/archiv/bundesrat',
            method: 'POST',
            headers,
            body: paginierungDTO,
        }, opts?.responseOpts);
    };

    /**
     * Ruft die Liste der archivierten Regelungsvorhaben ab (»Archiv«)
     * Lädt die Tabelle der Regelungsvorhaben für den Tab »Archiv«
     */
    getArchivBundestag({ paginierungDTO }: GetArchivBundestagRequest): Observable<RegelungsvorhabenBundestagTableDTOs>
    getArchivBundestag({ paginierungDTO }: GetArchivBundestagRequest, opts?: OperationOpts): Observable<AjaxResponse<RegelungsvorhabenBundestagTableDTOs>>
    getArchivBundestag({ paginierungDTO }: GetArchivBundestagRequest, opts?: OperationOpts): Observable<RegelungsvorhabenBundestagTableDTOs | AjaxResponse<RegelungsvorhabenBundestagTableDTOs>> {
        throwIfNullOrUndefined(paginierungDTO, 'paginierungDTO', 'getArchivBundestag');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<RegelungsvorhabenBundestagTableDTOs>({
            url: '/regelungsvorhaben/archiv/bundestag',
            method: 'POST',
            headers,
            body: paginierungDTO,
        }, opts?.responseOpts);
    };

    /**
     * Lädt die Bundesrats-Drucksachennummer eines RVs. Format ist `NNNNN/YY`.
     * Lädt die Tabelle der Regelungsvorhaben für den Tab »Regelungsvorhaben«
     */
    getBrDrucksachennummer({ id }: GetBrDrucksachennummerRequest): Observable<BoxString>
    getBrDrucksachennummer({ id }: GetBrDrucksachennummerRequest, opts?: OperationOpts): Observable<AjaxResponse<BoxString>>
    getBrDrucksachennummer({ id }: GetBrDrucksachennummerRequest, opts?: OperationOpts): Observable<BoxString | AjaxResponse<BoxString>> {
        throwIfNullOrUndefined(id, 'id', 'getBrDrucksachennummer');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<BoxString>({
            url: '/regelungsvorhaben/{id}/bundesrat/drucksachennummer'.replace('{id}', encodeURI(id)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Ruft die Liste der Regelungsvorhaben des Anwenders in Entwurf ab (»Entwürfe«)
     * Lädt die Tabelle der Regelungsvorhaben für den Tab »Entwürfe« (nicht verfügbar in PKP!)
     */
    getEntwuerfe({ paginierungDTO }: GetEntwuerfeRequest): Observable<RegelungsvorhabenBundesregierungTableDTOs>
    getEntwuerfe({ paginierungDTO }: GetEntwuerfeRequest, opts?: OperationOpts): Observable<AjaxResponse<RegelungsvorhabenBundesregierungTableDTOs>>
    getEntwuerfe({ paginierungDTO }: GetEntwuerfeRequest, opts?: OperationOpts): Observable<RegelungsvorhabenBundesregierungTableDTOs | AjaxResponse<RegelungsvorhabenBundesregierungTableDTOs>> {
        throwIfNullOrUndefined(paginierungDTO, 'paginierungDTO', 'getEntwuerfe');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<RegelungsvorhabenBundesregierungTableDTOs>({
            url: '/regelungsvorhaben/entwuerfe',
            method: 'POST',
            headers,
            body: paginierungDTO,
        }, opts?.responseOpts);
    };

    /**
     * Ruft die Liste der Regelungsvorhaben des Anwenders in Entwurf ab (»Entwürfe«)
     * Lädt die Tabelle der Regelungsvorhaben für den Tab »Entwürfe« (nicht verfügbar in PKP!)
     */
    getEntwuerfeBundestag({ paginierungDTO }: GetEntwuerfeBundestagRequest): Observable<RegelungsvorhabenBundestagTableDTOs>
    getEntwuerfeBundestag({ paginierungDTO }: GetEntwuerfeBundestagRequest, opts?: OperationOpts): Observable<AjaxResponse<RegelungsvorhabenBundestagTableDTOs>>
    getEntwuerfeBundestag({ paginierungDTO }: GetEntwuerfeBundestagRequest, opts?: OperationOpts): Observable<RegelungsvorhabenBundestagTableDTOs | AjaxResponse<RegelungsvorhabenBundestagTableDTOs>> {
        throwIfNullOrUndefined(paginierungDTO, 'paginierungDTO', 'getEntwuerfeBundestag');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<RegelungsvorhabenBundestagTableDTOs>({
            url: '/regelungsvorhaben/entwuerfe/bundestag',
            method: 'POST',
            headers,
            body: paginierungDTO,
        }, opts?.responseOpts);
    };

    /**
     * Ruft die Liste der Regelungsvorhaben des Bundesregierungsanwender in Bearbeitung ab (»Regelungsvorhaben«)
     * Lädt die Tabelle der Regelungsvorhaben für den Tab »Regelungsvorhaben«
     */
    getMeineRegelungsvorhaben({ paginierungDTO }: GetMeineRegelungsvorhabenRequest): Observable<RegelungsvorhabenBundesregierungTableDTOs>
    getMeineRegelungsvorhaben({ paginierungDTO }: GetMeineRegelungsvorhabenRequest, opts?: OperationOpts): Observable<AjaxResponse<RegelungsvorhabenBundesregierungTableDTOs>>
    getMeineRegelungsvorhaben({ paginierungDTO }: GetMeineRegelungsvorhabenRequest, opts?: OperationOpts): Observable<RegelungsvorhabenBundesregierungTableDTOs | AjaxResponse<RegelungsvorhabenBundesregierungTableDTOs>> {
        throwIfNullOrUndefined(paginierungDTO, 'paginierungDTO', 'getMeineRegelungsvorhaben');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<RegelungsvorhabenBundesregierungTableDTOs>({
            url: '/regelungsvorhaben/regelungsvorhaben',
            method: 'POST',
            headers,
            body: paginierungDTO,
        }, opts?.responseOpts);
    };

    /**
     * Ruft die Liste der Regelungsvorhaben des Bundesratsanwender in Bearbeitung ab (»Regelungsvorhaben«)
     * Lädt die Tabelle der Regelungsvorhaben für den Tab »Regelungsvorhaben«
     */
    getMeineRegelungsvorhabenBundesratGET({ eRSTELLER, iNITIANTUSER, iNITIANTINSTITUTION, vORHABENART, page, size, sort, permissibleStatuses, permissibleZuleitungFreigegebenFuer }: GetMeineRegelungsvorhabenBundesratGETRequest): Observable<RegelungsvorhabenBundesratTableDTOs>
    getMeineRegelungsvorhabenBundesratGET({ eRSTELLER, iNITIANTUSER, iNITIANTINSTITUTION, vORHABENART, page, size, sort, permissibleStatuses, permissibleZuleitungFreigegebenFuer }: GetMeineRegelungsvorhabenBundesratGETRequest, opts?: OperationOpts): Observable<AjaxResponse<RegelungsvorhabenBundesratTableDTOs>>
    getMeineRegelungsvorhabenBundesratGET({ eRSTELLER, iNITIANTUSER, iNITIANTINSTITUTION, vORHABENART, page, size, sort, permissibleStatuses, permissibleZuleitungFreigegebenFuer }: GetMeineRegelungsvorhabenBundesratGETRequest, opts?: OperationOpts): Observable<RegelungsvorhabenBundesratTableDTOs | AjaxResponse<RegelungsvorhabenBundesratTableDTOs>> {

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        const query: HttpQuery = {};

        if (eRSTELLER != null) { query['ERSTELLER'] = eRSTELLER; }
        if (iNITIANTUSER != null) { query['INITIANT_USER'] = iNITIANTUSER; }
        if (iNITIANTINSTITUTION != null) { query['INITIANT_INSTITUTION'] = iNITIANTINSTITUTION; }
        if (vORHABENART != null) { query['VORHABENART'] = vORHABENART; }
        if (page != null) { query['page'] = page; }
        if (size != null) { query['size'] = size; }
        if (sort != null) { query['sort'] = sort; }
        if (permissibleStatuses != null) { query['permissibleStatuses'] = permissibleStatuses; }
        if (permissibleZuleitungFreigegebenFuer != null) { query['permissibleZuleitungFreigegebenFuer'] = permissibleZuleitungFreigegebenFuer; }

        return this.request<RegelungsvorhabenBundesratTableDTOs>({
            url: '/regelungsvorhaben/bundesrat',
            method: 'GET',
            headers,
            query,
        }, opts?.responseOpts);
    };

    /**
     * Ruft die Liste der Regelungsvorhaben des Bundestagsanwender in Bearbeitung ab (»Regelungsvorhaben«)
     * Lädt die Tabelle der Regelungsvorhaben für den Tab »Regelungsvorhaben«
     */
    getMeineRegelungsvorhabenBundestag({ paginierungDTO }: GetMeineRegelungsvorhabenBundestagRequest): Observable<RegelungsvorhabenBundestagTableDTOs>
    getMeineRegelungsvorhabenBundestag({ paginierungDTO }: GetMeineRegelungsvorhabenBundestagRequest, opts?: OperationOpts): Observable<AjaxResponse<RegelungsvorhabenBundestagTableDTOs>>
    getMeineRegelungsvorhabenBundestag({ paginierungDTO }: GetMeineRegelungsvorhabenBundestagRequest, opts?: OperationOpts): Observable<RegelungsvorhabenBundestagTableDTOs | AjaxResponse<RegelungsvorhabenBundestagTableDTOs>> {
        throwIfNullOrUndefined(paginierungDTO, 'paginierungDTO', 'getMeineRegelungsvorhabenBundestag');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<RegelungsvorhabenBundestagTableDTOs>({
            url: '/regelungsvorhaben/regelungsvorhaben/bundestag',
            method: 'POST',
            headers,
            body: paginierungDTO,
        }, opts?.responseOpts);
    };

    /**
     * Ruft die Übersicht für die Prozesshilfe ab
     * Lädt die Übersichtsseite für die RV-Prozesshilfe
     */
    getProzesshilfeUebersicht({ id }: GetProzesshilfeUebersichtRequest): Observable<RvProzesshilfeOverviewDTO>
    getProzesshilfeUebersicht({ id }: GetProzesshilfeUebersichtRequest, opts?: OperationOpts): Observable<AjaxResponse<RvProzesshilfeOverviewDTO>>
    getProzesshilfeUebersicht({ id }: GetProzesshilfeUebersichtRequest, opts?: OperationOpts): Observable<RvProzesshilfeOverviewDTO | AjaxResponse<RvProzesshilfeOverviewDTO>> {
        throwIfNullOrUndefined(id, 'id', 'getProzesshilfeUebersicht');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<RvProzesshilfeOverviewDTO>({
            url: '/regelungsvorhaben/{id}/prozesshilfe/overview'.replace('{id}', encodeURI(id)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Ruft die Übersicht für die Prozesshilfe für Detailansicht eines RV im Bundesrat ab.
     * Lädt die Übersichtsseite für die RV-Prozesshilfe
     */
    getProzesshilfeUebersichtNoAuth({ id }: GetProzesshilfeUebersichtNoAuthRequest): Observable<RvProzesshilfeOverviewDTO>
    getProzesshilfeUebersichtNoAuth({ id }: GetProzesshilfeUebersichtNoAuthRequest, opts?: OperationOpts): Observable<AjaxResponse<RvProzesshilfeOverviewDTO>>
    getProzesshilfeUebersichtNoAuth({ id }: GetProzesshilfeUebersichtNoAuthRequest, opts?: OperationOpts): Observable<RvProzesshilfeOverviewDTO | AjaxResponse<RvProzesshilfeOverviewDTO>> {
        throwIfNullOrUndefined(id, 'id', 'getProzesshilfeUebersichtNoAuth');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<RvProzesshilfeOverviewDTO>({
            url: '/regelungsvorhaben/{id}/prozesshilfe/overview/bundesrat'.replace('{id}', encodeURI(id)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Lädt ein vollständiges Regelungsvorhaben zur Bearbeitung.
     * Lädt ein Regelungsvorhaben zur Bearbeitung. Nur zum Anlegen, zum Löschen und ggf. für die Review Page verwenden!
     */
    getRegelungsvorhaben({ id }: GetRegelungsvorhabenRequest): Observable<RegelungsvorhabenEntityResponseDTO>
    getRegelungsvorhaben({ id }: GetRegelungsvorhabenRequest, opts?: OperationOpts): Observable<AjaxResponse<RegelungsvorhabenEntityResponseDTO>>
    getRegelungsvorhaben({ id }: GetRegelungsvorhabenRequest, opts?: OperationOpts): Observable<RegelungsvorhabenEntityResponseDTO | AjaxResponse<RegelungsvorhabenEntityResponseDTO>> {
        throwIfNullOrUndefined(id, 'id', 'getRegelungsvorhaben');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<RegelungsvorhabenEntityResponseDTO>({
            url: '/regelungsvorhaben/{id}'.replace('{id}', encodeURI(id)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Ruft die Liste der Bestandsrechte einer Regelungsvorhaben auf
     * Lädt die Liste der Regelungsvorhaben Bestandsrechte
     */
    getRegelungsvorhabenBestandsrechtTable({ id }: GetRegelungsvorhabenBestandsrechtTableRequest): Observable<Array<RegelungsvorhabenBestandsrechtTableDTO>>
    getRegelungsvorhabenBestandsrechtTable({ id }: GetRegelungsvorhabenBestandsrechtTableRequest, opts?: OperationOpts): Observable<AjaxResponse<Array<RegelungsvorhabenBestandsrechtTableDTO>>>
    getRegelungsvorhabenBestandsrechtTable({ id }: GetRegelungsvorhabenBestandsrechtTableRequest, opts?: OperationOpts): Observable<Array<RegelungsvorhabenBestandsrechtTableDTO> | AjaxResponse<Array<RegelungsvorhabenBestandsrechtTableDTO>>> {
        throwIfNullOrUndefined(id, 'id', 'getRegelungsvorhabenBestandsrechtTable');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<Array<RegelungsvorhabenBestandsrechtTableDTO>>({
            url: '/regelungsvorhaben/{id}/bestandsrechte'.replace('{id}', encodeURI(id)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Ruft die Liste der Regelungsvorhaben des Fachadministrators (Bundesregierung), bei dem sein Ressort als koordinierende Federführung eingetragen ist.
     * Lädt die Tabelle der Regelungsvorhaben für den Fachadministrator der Bundesregierung
     */
    getRegelungsvorhabenFachadministrator({ paginierungDTO }: GetRegelungsvorhabenFachadministratorRequest): Observable<RegelungsvorhabenFachadminTableDTO>
    getRegelungsvorhabenFachadministrator({ paginierungDTO }: GetRegelungsvorhabenFachadministratorRequest, opts?: OperationOpts): Observable<AjaxResponse<RegelungsvorhabenFachadminTableDTO>>
    getRegelungsvorhabenFachadministrator({ paginierungDTO }: GetRegelungsvorhabenFachadministratorRequest, opts?: OperationOpts): Observable<RegelungsvorhabenFachadminTableDTO | AjaxResponse<RegelungsvorhabenFachadminTableDTO>> {
        throwIfNullOrUndefined(paginierungDTO, 'paginierungDTO', 'getRegelungsvorhabenFachadministrator');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<RegelungsvorhabenFachadminTableDTO>({
            url: '/regelungsvorhaben/fachadministrator',
            method: 'POST',
            headers,
            body: paginierungDTO,
        }, opts?.responseOpts);
    };

    /**
     * Gibt eine Liste von Regelungsvorhaben zurück, die aus PKP stammen
     * Zeigt eine Liste von Regelungsvorhaben aus PKP
     */
    getRegelungsvorhabenFromPkpList(): Observable<Array<RegelungsvorhabenPpkTableDTO>>
    getRegelungsvorhabenFromPkpList(opts?: OperationOpts): Observable<AjaxResponse<Array<RegelungsvorhabenPpkTableDTO>>>
    getRegelungsvorhabenFromPkpList(opts?: OperationOpts): Observable<Array<RegelungsvorhabenPpkTableDTO> | AjaxResponse<Array<RegelungsvorhabenPpkTableDTO>>> {
        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<Array<RegelungsvorhabenPpkTableDTO>>({
            url: '/regelungsvorhaben/pkp',
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Lädt ein vollständiges Regelungsvorhaben
     * Lädt ein Regelungsvorhaben (full)
     */
    getRegelungsvorhabenFull({ id }: GetRegelungsvorhabenFullRequest): Observable<RegelungsvorhabenEntityFullResponseDTO>
    getRegelungsvorhabenFull({ id }: GetRegelungsvorhabenFullRequest, opts?: OperationOpts): Observable<AjaxResponse<RegelungsvorhabenEntityFullResponseDTO>>
    getRegelungsvorhabenFull({ id }: GetRegelungsvorhabenFullRequest, opts?: OperationOpts): Observable<RegelungsvorhabenEntityFullResponseDTO | AjaxResponse<RegelungsvorhabenEntityFullResponseDTO>> {
        throwIfNullOrUndefined(id, 'id', 'getRegelungsvorhabenFull');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<RegelungsvorhabenEntityFullResponseDTO>({
            url: '/regelungsvorhaben/full/{id}'.replace('{id}', encodeURI(id)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Ruft Regelungsvorhaben in Kurzform ab.
     * Lädt die Liste der Regelungsvorhaben (short). Filtert standardmäßig nach RVs, für die kein Umlauf existiert.
     */
    getRegelungsvorhabenShort({ permissibleStatuses, permissibleZuleitungFreigegebenFuer, permissibleZuleitungRueckmeldung, requireUmlaufNull, requireGrunddrucksacheExists, page, size, sort }: GetRegelungsvorhabenShortRequest): Observable<PageRegelungsvorhabenEntityResponseShortDTO>
    getRegelungsvorhabenShort({ permissibleStatuses, permissibleZuleitungFreigegebenFuer, permissibleZuleitungRueckmeldung, requireUmlaufNull, requireGrunddrucksacheExists, page, size, sort }: GetRegelungsvorhabenShortRequest, opts?: OperationOpts): Observable<AjaxResponse<PageRegelungsvorhabenEntityResponseShortDTO>>
    getRegelungsvorhabenShort({ permissibleStatuses, permissibleZuleitungFreigegebenFuer, permissibleZuleitungRueckmeldung, requireUmlaufNull, requireGrunddrucksacheExists, page, size, sort }: GetRegelungsvorhabenShortRequest, opts?: OperationOpts): Observable<PageRegelungsvorhabenEntityResponseShortDTO | AjaxResponse<PageRegelungsvorhabenEntityResponseShortDTO>> {

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        const query: HttpQuery = {};

        if (permissibleStatuses != null) { query['permissibleStatuses'] = permissibleStatuses; }
        if (permissibleZuleitungFreigegebenFuer != null) { query['permissibleZuleitungFreigegebenFuer'] = permissibleZuleitungFreigegebenFuer; }
        if (permissibleZuleitungRueckmeldung != null) { query['permissibleZuleitungRueckmeldung'] = permissibleZuleitungRueckmeldung; }
        if (requireUmlaufNull != null) { query['requireUmlaufNull'] = requireUmlaufNull; }
        if (requireGrunddrucksacheExists != null) { query['requireGrunddrucksacheExists'] = requireGrunddrucksacheExists; }
        if (page != null) { query['page'] = page; }
        if (size != null) { query['size'] = size; }
        if (sort != null) { query['sort'] = sort; }

        return this.request<PageRegelungsvorhabenEntityResponseShortDTO>({
            url: '/regelungsvorhaben/short',
            method: 'GET',
            headers,
            query,
        }, opts?.responseOpts);
    };

    /**
     * Ruft die Liste der Regelungsvorhaben ab. Hinweis: Liefert nur Regelungsvorhaben im Status IN_BEARBEITUNG.
     * Lädt die Liste der Regelungsvorhaben (short)
     */
    getRegelungsvorhabenShortList(): Observable<RegelungsvorhabenEntityListResponseShortDTO>
    getRegelungsvorhabenShortList(opts?: OperationOpts): Observable<AjaxResponse<RegelungsvorhabenEntityListResponseShortDTO>>
    getRegelungsvorhabenShortList(opts?: OperationOpts): Observable<RegelungsvorhabenEntityListResponseShortDTO | AjaxResponse<RegelungsvorhabenEntityListResponseShortDTO>> {
        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<RegelungsvorhabenEntityListResponseShortDTO>({
            url: '/regelungsvorhaben/short/list',
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Ruft die Liste der Regelungsvorhaben ab. Hinweis: Liefert nur Regelungsvorhaben im Status IN_BEARBEITUNG und BUNDESTAG für die Startseite
     * Lädt die Liste der Regelungsvorhaben (short)
     */
    getRegelungsvorhabenShortListForStartseite(): Observable<RegelungsvorhabenEntityListResponseShortDTO>
    getRegelungsvorhabenShortListForStartseite(opts?: OperationOpts): Observable<AjaxResponse<RegelungsvorhabenEntityListResponseShortDTO>>
    getRegelungsvorhabenShortListForStartseite(opts?: OperationOpts): Observable<RegelungsvorhabenEntityListResponseShortDTO | AjaxResponse<RegelungsvorhabenEntityListResponseShortDTO>> {
        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<RegelungsvorhabenEntityListResponseShortDTO>({
            url: '/regelungsvorhaben/short/list/startseite',
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Ruft die Liste der Regelungsvorhaben ab, zu denen noch kein Umlauf existiert. Hinweis: Liefert nur Regelungsvorhaben im Status IN_BEARBEITUNG und BUNDESTAG.
     * Lädt die Liste der Regelungsvorhaben (short) für die kein Umlauf existiert
     */
    getRegelungsvorhabenShortListWithoutUmlauf({ permissibleStatuses, permissibleZuleitungFreigegebenFuer, permissibleZuleitungRueckmeldung, requireUmlaufNull, requireGrunddrucksacheExists, page, size, sort }: GetRegelungsvorhabenShortListWithoutUmlaufRequest): Observable<RegelungsvorhabenEntityListResponseShortDTO>
    getRegelungsvorhabenShortListWithoutUmlauf({ permissibleStatuses, permissibleZuleitungFreigegebenFuer, permissibleZuleitungRueckmeldung, requireUmlaufNull, requireGrunddrucksacheExists, page, size, sort }: GetRegelungsvorhabenShortListWithoutUmlaufRequest, opts?: OperationOpts): Observable<AjaxResponse<RegelungsvorhabenEntityListResponseShortDTO>>
    getRegelungsvorhabenShortListWithoutUmlauf({ permissibleStatuses, permissibleZuleitungFreigegebenFuer, permissibleZuleitungRueckmeldung, requireUmlaufNull, requireGrunddrucksacheExists, page, size, sort }: GetRegelungsvorhabenShortListWithoutUmlaufRequest, opts?: OperationOpts): Observable<RegelungsvorhabenEntityListResponseShortDTO | AjaxResponse<RegelungsvorhabenEntityListResponseShortDTO>> {

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        const query: HttpQuery = {};

        if (permissibleStatuses != null) { query['permissibleStatuses'] = permissibleStatuses; }
        if (permissibleZuleitungFreigegebenFuer != null) { query['permissibleZuleitungFreigegebenFuer'] = permissibleZuleitungFreigegebenFuer; }
        if (permissibleZuleitungRueckmeldung != null) { query['permissibleZuleitungRueckmeldung'] = permissibleZuleitungRueckmeldung; }
        if (requireUmlaufNull != null) { query['requireUmlaufNull'] = requireUmlaufNull; }
        if (requireGrunddrucksacheExists != null) { query['requireGrunddrucksacheExists'] = requireGrunddrucksacheExists; }
        if (page != null) { query['page'] = page; }
        if (size != null) { query['size'] = size; }
        if (sort != null) { query['sort'] = sort; }

        return this.request<RegelungsvorhabenEntityListResponseShortDTO>({
            url: '/regelungsvorhaben/short/list/withoutumlauf',
            method: 'GET',
            headers,
            query,
        }, opts?.responseOpts);
    };

    /**
     * Ruft die Liste der Zuleitungen eines Regelungsvorhaben auf
     * Lädt die Liste der Regelungsvorhaben Zuleitungen
     */
    getRegelungsvorhabenZuleitungTable({ id }: GetRegelungsvorhabenZuleitungTableRequest): Observable<Array<RegelungsvorhabenZuleitungTableDTO>>
    getRegelungsvorhabenZuleitungTable({ id }: GetRegelungsvorhabenZuleitungTableRequest, opts?: OperationOpts): Observable<AjaxResponse<Array<RegelungsvorhabenZuleitungTableDTO>>>
    getRegelungsvorhabenZuleitungTable({ id }: GetRegelungsvorhabenZuleitungTableRequest, opts?: OperationOpts): Observable<Array<RegelungsvorhabenZuleitungTableDTO> | AjaxResponse<Array<RegelungsvorhabenZuleitungTableDTO>>> {
        throwIfNullOrUndefined(id, 'id', 'getRegelungsvorhabenZuleitungTable');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<Array<RegelungsvorhabenZuleitungTableDTO>>({
            url: '/regelungsvorhaben/{id}/zuleitungen'.replace('{id}', encodeURI(id)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Ruft die Liste der Zuleitungen eines Regelungsvorhaben auf
     * Lädt die Liste der Regelungsvorhaben Zuleitungen für den Bundestag
     */
    getRegelungsvorhabenZuleitungTableBundestag({ id }: GetRegelungsvorhabenZuleitungTableBundestagRequest): Observable<Array<RegelungsvorhabenZuleitungTableDTO>>
    getRegelungsvorhabenZuleitungTableBundestag({ id }: GetRegelungsvorhabenZuleitungTableBundestagRequest, opts?: OperationOpts): Observable<AjaxResponse<Array<RegelungsvorhabenZuleitungTableDTO>>>
    getRegelungsvorhabenZuleitungTableBundestag({ id }: GetRegelungsvorhabenZuleitungTableBundestagRequest, opts?: OperationOpts): Observable<Array<RegelungsvorhabenZuleitungTableDTO> | AjaxResponse<Array<RegelungsvorhabenZuleitungTableDTO>>> {
        throwIfNullOrUndefined(id, 'id', 'getRegelungsvorhabenZuleitungTableBundestag');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<Array<RegelungsvorhabenZuleitungTableDTO>>({
            url: '/regelungsvorhaben/{id}/zuleitungen/bundestag'.replace('{id}', encodeURI(id)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Liefert die Liste der Files eines Regelungsvorhaben
     * Lädt die Dateien eines Regelungsvorhabens
     */
    getRvFiles({ id }: GetRvFilesRequest): Observable<Array<RvFileEntityResponseDTO>>
    getRvFiles({ id }: GetRvFilesRequest, opts?: OperationOpts): Observable<AjaxResponse<Array<RvFileEntityResponseDTO>>>
    getRvFiles({ id }: GetRvFilesRequest, opts?: OperationOpts): Observable<Array<RvFileEntityResponseDTO> | AjaxResponse<Array<RvFileEntityResponseDTO>>> {
        throwIfNullOrUndefined(id, 'id', 'getRvFiles');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<Array<RvFileEntityResponseDTO>>({
            url: '/regelungsvorhaben/{id}/files'.replace('{id}', encodeURI(id)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Lädt die Tagesordnungsrelevanz eines RV
     * Lädt Tagesordnungsrelevanz
     */
    getTagesordnungsrelevanz({ id }: GetTagesordnungsrelevanzRequest): Observable<TagesordnungsrelevanzDTO>
    getTagesordnungsrelevanz({ id }: GetTagesordnungsrelevanzRequest, opts?: OperationOpts): Observable<AjaxResponse<TagesordnungsrelevanzDTO>>
    getTagesordnungsrelevanz({ id }: GetTagesordnungsrelevanzRequest, opts?: OperationOpts): Observable<TagesordnungsrelevanzDTO | AjaxResponse<TagesordnungsrelevanzDTO>> {
        throwIfNullOrUndefined(id, 'id', 'getTagesordnungsrelevanz');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<TagesordnungsrelevanzDTO>({
            url: '/regelungsvorhaben/{id}/tagesordnungsrelevanz'.replace('{id}', encodeURI(id)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Ändert ein Regelungsvorhaben
     * Verändert ein Regelungsvorhaben
     */
    modifyRegelungsvorhaben({ id, regelungsvorhabenEntityDTO }: ModifyRegelungsvorhabenRequest): Observable<RegelungsvorhabenEntityResponseDTO>
    modifyRegelungsvorhaben({ id, regelungsvorhabenEntityDTO }: ModifyRegelungsvorhabenRequest, opts?: OperationOpts): Observable<AjaxResponse<RegelungsvorhabenEntityResponseDTO>>
    modifyRegelungsvorhaben({ id, regelungsvorhabenEntityDTO }: ModifyRegelungsvorhabenRequest, opts?: OperationOpts): Observable<RegelungsvorhabenEntityResponseDTO | AjaxResponse<RegelungsvorhabenEntityResponseDTO>> {
        throwIfNullOrUndefined(id, 'id', 'modifyRegelungsvorhaben');
        throwIfNullOrUndefined(regelungsvorhabenEntityDTO, 'regelungsvorhabenEntityDTO', 'modifyRegelungsvorhaben');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<RegelungsvorhabenEntityResponseDTO>({
            url: '/regelungsvorhaben/{id}'.replace('{id}', encodeURI(id)),
            method: 'PUT',
            headers,
            body: regelungsvorhabenEntityDTO,
        }, opts?.responseOpts);
    };

    /**
     * Ändert die Farbe für die Startseite eines Regelungsvorhaben
     * Verändert die Farbe eines Regelungsvorhabens
     */
    modifyRvFarbe({ id, farbeType }: ModifyRvFarbeRequest): Observable<RegelungsvorhabenEntityResponseDTO>
    modifyRvFarbe({ id, farbeType }: ModifyRvFarbeRequest, opts?: OperationOpts): Observable<AjaxResponse<RegelungsvorhabenEntityResponseDTO>>
    modifyRvFarbe({ id, farbeType }: ModifyRvFarbeRequest, opts?: OperationOpts): Observable<RegelungsvorhabenEntityResponseDTO | AjaxResponse<RegelungsvorhabenEntityResponseDTO>> {
        throwIfNullOrUndefined(id, 'id', 'modifyRvFarbe');
        throwIfNullOrUndefined(farbeType, 'farbeType', 'modifyRvFarbe');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<RegelungsvorhabenEntityResponseDTO>({
            url: '/regelungsvorhaben/{id}/farbe/{farbeType}'.replace('{id}', encodeURI(id)).replace('{farbeType}', encodeURI(farbeType)),
            method: 'PUT',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Setzt die Tagesordnungsrelevanz eines RV
     * Setzt Tagesordnungsrelevanz
     */
    modifyTagesordnungsrelevanz({ id, tagesordnungsrelevanzDTO }: ModifyTagesordnungsrelevanzRequest): Observable<void>
    modifyTagesordnungsrelevanz({ id, tagesordnungsrelevanzDTO }: ModifyTagesordnungsrelevanzRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    modifyTagesordnungsrelevanz({ id, tagesordnungsrelevanzDTO }: ModifyTagesordnungsrelevanzRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(id, 'id', 'modifyTagesordnungsrelevanz');
        throwIfNullOrUndefined(tagesordnungsrelevanzDTO, 'tagesordnungsrelevanzDTO', 'modifyTagesordnungsrelevanz');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/regelungsvorhaben/{id}/modifyTagesordnungsrelevanz'.replace('{id}', encodeURI(id)),
            method: 'POST',
            headers,
            body: tagesordnungsrelevanzDTO,
        }, opts?.responseOpts);
    };

    /**
     * Sendet das Regelungsvorhaben nach PKP
     * Erstellt oder aktualisiert das RV in PKP
     */
    sendRvToPkp({ id }: SendRvToPkpRequest): Observable<PkpGesendetStatusType>
    sendRvToPkp({ id }: SendRvToPkpRequest, opts?: OperationOpts): Observable<AjaxResponse<PkpGesendetStatusType>>
    sendRvToPkp({ id }: SendRvToPkpRequest, opts?: OperationOpts): Observable<PkpGesendetStatusType | AjaxResponse<PkpGesendetStatusType>> {
        throwIfNullOrUndefined(id, 'id', 'sendRvToPkp');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<PkpGesendetStatusType>({
            url: '/regelungsvorhaben/{id}/pkp-senden'.replace('{id}', encodeURI(id)),
            method: 'PUT',
            headers,
        }, opts?.responseOpts);
    };

}
